diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
index cee09c2c5..6db888133 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
@@ -10,119 +10,112 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
+import org.jetbrains.annotations.NotNull;
 
-public class WeatherSnow extends Weather
-{
-
-	public WeatherSnow(int id)
-	{
-		super(id);
-	}
-
-	@Override
-	public String getPrecipitationTexture(World world)
-	{
-		if (world.weatherManager.getWeatherPower() <= 0.6f)
-		{
-			return "/assets/minecraft/textures/environment/snow_light.png";
-		}
-		else
-		{
-			return "/assets/minecraft/textures/environment/snow.png";
-		}
-	}
-
-	@Override
-	public void doChunkLoadEffect(World world, Chunk chunk)
-	{
-		if (world.weatherManager.getWeatherPower() <= 0.6f) return;
-		for (int x = 0; x < 16; x++)
-		{
-			int worldX = chunk.xPosition * 16 + x;
-zLoop:		for (int z = 0; z < 16; z++)
-			{
-				int worldZ = chunk.zPosition * 16 + z;
-				int y = world.findTopSolidBlock(worldX, worldZ);
-
-				Biome biome = world.getBlockBiome(worldX, y, worldZ);
-				for (int i = 0; i < biome.blockedWeathers.length; i++)
-				{
-					if (biome.blockedWeathers[i] == this) continue zLoop;
-				}
-
-				int blockId = chunk.getBlockID(x, y, z);
-				int blockIdBelow = chunk.getBlockID(x, y - 1, z);
-
-				if (y >= 0 && y < world.getHeightBlocks() && chunk.getBrightness(LightLayer.Block, x, y, z) < 10)
-				{
-					if (blockId == 0 && Blocks.LAYER_SNOW.canPlaceBlockAt(world, worldX, y, worldZ) && blockIdBelow != Blocks.ICE.id())
-					{
-						chunk.setBlockIDWithMetadataRaw(x, y, z, Blocks.LAYER_SNOW.id(), chunk.getBlockMetadata(x, y, z));
-					}
-					else if (blockIdBelow == Blocks.FLUID_WATER_STILL.id() && chunk.getBlockMetadata(x, y - 1, z) == 0) {
-						chunk.setBlockIDWithMetadataRaw(x, y - 1, z, Blocks.ICE.id(), chunk.getBlockMetadata(x, y - 1, z));
-						if (chunk.getBlockID(x, y - 2, z) == Blocks.FLUID_WATER_STILL.id()){
-							chunk.setBlockIDWithMetadataRaw(x, y - 2, z, Blocks.FLUID_WATER_FLOWING.id(), chunk.getBlockMetadata(x, y - 2, z));
-						}
-					}
-				}
-			}
-		}
-	}
-
-	@Override
-	public void doEnvironmentUpdate(World world, Random rand, int x, int z)
-	{
-		int probability = (int)(64 * (1 / world.weatherManager.getWeatherPower()));
-		if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasDeeperSnow)
-		{
-			probability /= 2;
-		}
-		
-		boolean snow = rand.nextInt(probability) == 0;
-		
-		int y = world.findTopSolidBlock(x, z);
-		
-		int blockId = world.getBlockId(x, y, z);
-		int blockIdBelow = world.getBlockId(x, y - 1, z);
-		
-		Biome biome = world.getBlockBiome(x, y, z);
-		for (int i = 0; i < biome.blockedWeathers.length; i++)
-		{
-			if (biome.blockedWeathers[i] == this) return;
-		}
-		
-		if (world.weatherManager.getWeatherPower() > 0.6f && y >= 0 && y < world.getHeightBlocks() && world.getSavedLightValue(LightLayer.Block, x, y, z) < 10)
-		{
-			if (blockId == 0 && blockIdBelow != 0 && Blocks.LAYER_SNOW.canPlaceBlockAt(world, x, y, z) && blockIdBelow != Blocks.ICE.id())
-			{
-				if(snow)
-				{
-					world.setBlockWithNotify(x, y, z, Blocks.LAYER_SNOW.id());
-				}
-			}
-			else if (world.weatherManager.getWeatherPower() > 0.5f && blockId == Blocks.LAYER_SNOW.id() && world.getSeasonManager().getCurrentSeason() != null && (world.getSeasonManager().getCurrentSeason().hasDeeperSnow || biome == Biomes.OVERWORLD_GLACIER))
-			{
-				if(snow) {
-					Blocks.LAYER_SNOW.getLogic().accumulate(world, x, y, z);
-				}
-			}
-			else if (blockIdBelow == Blocks.FLUID_WATER_STILL.id() && world.getBlockMetadata(x, y - 1, z) == 0)
-			{
-				if(rand.nextFloat() < world.weatherManager.getWeatherPower() * world.weatherManager.getWeatherIntensity())
-				{
-					for(int i=0; i < 4; i++)
-					{
-						Direction direction = Direction.horizontalDirections[i];
-						Block<?> block = world.getBlock(x + direction.getOffsetX(), y - 1, z + direction.getOffsetZ());
-						if(block == Blocks.ICE || block != null && block.isSolidRender())
-						{
-							world.setBlockWithNotify(x, y - 1, z, Blocks.ICE.id());
-							break;
-						}
-					}	
-				}
-			}
-		}
-	}
+public class WeatherSnow
+    extends Weather
+    implements IPrecipitation {
+
+    public WeatherSnow(final int id, final @NotNull String languageKey, final @NotNull WeatherConfig weatherConfig) {
+        super(id, languageKey, weatherConfig);
+    }
+
+    @Override
+    public @NotNull Type getPrecipitationType() {
+        return Type.SNOW_LIKE;
+    }
+
+    @Override
+    public @NotNull String getPrecipitationTexturePath(final float power, final float intensity) {
+        if (power <= 0.6f) {
+            return "/assets/minecraft/textures/environment/snow_light.png";
+        } else {
+            return "/assets/minecraft/textures/environment/snow.png";
+        }
+    }
+
+    @Override
+    public boolean spawnRainParticles() {
+        return false;
+    }
+
+    @Override
+    public void doChunkLoadEffect(@NotNull World world, @NotNull Chunk chunk) {
+        if (world.weatherManager.getWeatherPower() <= 0.6f) return;
+        for (int x = 0; x < 16; x++) {
+            int worldX = chunk.xPosition * 16 + x;
+            zLoop:
+            for (int z = 0; z < 16; z++) {
+                int worldZ = chunk.zPosition * 16 + z;
+                int y = world.findTopSolidBlock(worldX, worldZ);
+
+                Biome biome = world.getBlockBiome(worldX, y, worldZ);
+                for (int i = 0; i < biome.blockedWeathers.length; i++) {
+                    if (biome.blockedWeathers[i] == this) continue zLoop;
+                }
+
+                int blockId = chunk.getBlockID(x, y, z);
+                int blockIdBelow = chunk.getBlockID(x, y - 1, z);
+
+                if (y >= 0 && y < world.getHeightBlocks() && chunk.getBrightness(LightLayer.Block, x, y, z) < 10) {
+                    if (blockId == 0 && Blocks.LAYER_SNOW.canPlaceBlockAt(world, worldX, y, worldZ) && blockIdBelow != Blocks.ICE.id()) {
+                        chunk.setBlockIDWithMetadataRaw(x, y, z, Blocks.LAYER_SNOW.id(), chunk.getBlockMetadata(x, y, z));
+                    } else if (blockIdBelow == Blocks.FLUID_WATER_STILL.id() && chunk.getBlockMetadata(x, y - 1, z) == 0) {
+                        chunk.setBlockIDWithMetadataRaw(x, y - 1, z, Blocks.ICE.id(), chunk.getBlockMetadata(x, y - 1, z));
+                        if (chunk.getBlockID(x, y - 2, z) == Blocks.FLUID_WATER_STILL.id()) {
+                            chunk.setBlockIDWithMetadataRaw(x, y - 2, z, Blocks.FLUID_WATER_FLOWING.id(), chunk.getBlockMetadata(x, y - 2, z));
+                        }
+                    }
+                }
+            }
+        }
+    }
+
+    @Override
+    public float @NotNull [] modifyFogColor(final float r, final float g, final float b, final float intensity) {
+        return new float[]{r, g, b};
+    }
+
+    @Override
+    public void doEnvironmentUpdate(@NotNull World world, @NotNull Random rand, int x, int z) {
+        int probability = (int) (64 * (1 / world.weatherManager.getWeatherPower()));
+        if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasDeeperSnow) {
+            probability /= 2;
+        }
+
+        boolean snow = rand.nextInt(probability) == 0;
+
+        int y = world.findTopSolidBlock(x, z);
+
+        int blockId = world.getBlockId(x, y, z);
+        int blockIdBelow = world.getBlockId(x, y - 1, z);
+
+        Biome biome = world.getBlockBiome(x, y, z);
+        for (int i = 0; i < biome.blockedWeathers.length; i++) {
+            if (biome.blockedWeathers[i] == this) return;
+        }
+
+        if (world.weatherManager.getWeatherPower() > 0.6f && y >= 0 && y < world.getHeightBlocks() && world.getSavedLightValue(LightLayer.Block, x, y, z) < 10) {
+            if (blockId == 0 && blockIdBelow != 0 && Blocks.LAYER_SNOW.canPlaceBlockAt(world, x, y, z) && blockIdBelow != Blocks.ICE.id()) {
+                if (snow) {
+                    world.setBlockWithNotify(x, y, z, Blocks.LAYER_SNOW.id());
+                }
+            } else if (world.weatherManager.getWeatherPower() > 0.5f && blockId == Blocks.LAYER_SNOW.id() && world.getSeasonManager().getCurrentSeason() != null && (world.getSeasonManager().getCurrentSeason().hasDeeperSnow || biome == Biomes.OVERWORLD_GLACIER)) {
+                if (snow) {
+                    Blocks.LAYER_SNOW.getLogic().accumulate(world, x, y, z);
+                }
+            } else if (blockIdBelow == Blocks.FLUID_WATER_STILL.id() && world.getBlockMetadata(x, y - 1, z) == 0) {
+                if (rand.nextFloat() < world.weatherManager.getWeatherPower() * world.weatherManager.getWeatherIntensity()) {
+                    for (int i = 0; i < 4; i++) {
+                        Direction direction = Direction.horizontalDirections[i];
+                        Block<?> block = world.getBlock(x + direction.getOffsetX(), y - 1, z + direction.getOffsetZ());
+                        if (block == Blocks.ICE || block != null && block.isSolidRender()) {
+                            world.setBlockWithNotify(x, y - 1, z, Blocks.ICE.id());
+                            break;
+                        }
+                    }
+                }
+            }
+        }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
index f714ff933..6c8784f47 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
@@ -6,81 +6,78 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.List;
 import java.util.Random;
 
-public class WeatherStorm extends WeatherRain
-{
-	public WeatherStorm(int id)
-	{
-		super(id);
-	}
-	
-	@Override
-	public float[] modifyFogColor(float r, float g, float b, float intensity)
-	{
-		float[] out = super.modifyFogColor(r, g, b, intensity);
-        float f9 = 1.0F - intensity * 0.5F;
-        out[0] *= f9;
-        out[1] *= f9;
-        out[2] *= f9;
-        
+public class WeatherStorm extends WeatherRain {
+
+    public WeatherStorm(final int id, final @NotNull String languageKey, final @NotNull WeatherConfig weatherConfig) {
+        super(id, languageKey, weatherConfig);
+    }
+
+    @Override
+    public float @NotNull [] modifyFogColor(final float r, final float g, final float b, final float intensity) {
+        final float[] out = super.modifyFogColor(r, g, b, intensity);
+        final float mod = 1.0F - intensity * 0.5F;
+        out[0] *= mod;
+        out[1] *= mod;
+        out[2] *= mod;
+
         return out;
-	}
-	
-	@Override
-	public void doEnvironmentUpdate(World world, Random rand, int x, int z)
-	{
-		super.doEnvironmentUpdate(world, rand, x, z);
-		
-		if (rand.nextInt((int)(100000 * (1 / world.weatherManager.getWeatherPower()))) == 0)
-		{
-			final int searchRadius = 32;
+    }
+
+    @Override
+    public void doEnvironmentUpdate(final @NotNull World world, final @NotNull Random rand, final int x, final int z) {
+        super.doEnvironmentUpdate(world, rand, x, z);
+
+        if (rand.nextInt((int) (100000 * (1 / world.weatherManager.getWeatherPower()))) == 0) {
+            final int searchRadius = 32;
+
+            int maxWeight = Integer.MIN_VALUE;
+            int targetX = x;
+            int targetY = world.getHeightValue(x, z);
+            int targetZ = z;
+            for (int _x = -searchRadius; _x <= searchRadius; _x++) {
+                for (int _z = -searchRadius; _z < searchRadius; _z++) {
+                    final int checkX = x + _x;
+                    final int checkZ = z + _z;
+                    final int checkY = world.getHeightValue(checkX, checkZ);
+                    final int weight = evalStrikeWeight(world, rand, x, z, checkX, checkY, checkZ);
+                    if (weight > maxWeight) {
+                        maxWeight = weight;
+                        targetX = checkX;
+                        targetY = checkY;
+                        targetZ = checkZ;
+                    }
+                }
+            }
 
-			int maxWeight = Integer.MIN_VALUE;
-			int targetX = x;
-			int targetY = world.getHeightValue(x, z);
-			int targetZ = z;
-			for (int _x = -searchRadius; _x <= searchRadius; _x++) {
-				for (int _z = -searchRadius; _z < searchRadius; _z++) {
-					int checkX = x + _x;
-					int checkZ = z + _z;
-					int checkY = world.getHeightValue(checkX, checkZ);
-					int weight = evalStrikeWeight(world, rand, x, z, checkX, checkY, checkZ);
-					if (weight > maxWeight){
-						maxWeight = weight;
-						targetX = checkX;
-						targetY = checkY;
-						targetZ = checkZ;
-					}
-				}
-			}
+            if (world.canBlockBeRainedOn(targetX, targetY, targetZ)) {
+                world.addWeatherEffect(new EntityLightning(world, targetX, targetY, targetZ));
+            }
+        }
+    }
 
-			if (world.canBlockBeRainedOn(targetX, targetY, targetZ))
-			{
-				world.addWeatherEffect(new EntityLightning(world, targetX, targetY, targetZ));
-			}			
-		}
-	}
-	public int evalStrikeWeight(World world, Random random, int orgX, int orgZ, int checkX, int checkY, int checkZ){
-		Material material = world.getBlockMaterial(checkX, checkY - 1, checkZ);
-		int weight = random.nextInt(10);
-		weight += checkY;
-		weight += material.getConductivity();
+    private static int evalStrikeWeight(final @NotNull World world, final @NotNull Random random, final int orgX, final int orgZ, final int checkX, final int checkY, final int checkZ) {
+        final @NotNull Material material = world.getBlockMaterial(checkX, checkY - 1, checkZ);
+        int weight = random.nextInt(10);
+        weight += checkY;
+        weight += material.getConductivity();
 
-		List<Mob> entityList = world.getEntitiesWithinAABB(Mob.class, AABB.getTemporaryBB(checkX, checkY, checkZ, checkX + 1, checkY + 1, checkZ + 1));
-		if (!entityList.isEmpty()){
-			weight += 4; // :)
-		}
+        final @NotNull List<@NotNull Mob> entityList = world.getEntitiesWithinAABB(Mob.class, AABB.getTemporaryBB(checkX, checkY, checkZ, checkX + 1, checkY + 1, checkZ + 1));
+        if (!entityList.isEmpty()) {
+            weight += 4; // :)
+        }
 
-		final int distX =  (checkX - orgX);
-		final int distZ =  (checkZ - orgZ);
-		final double dist = Math.sqrt(distX * distX + distZ + distZ);
-		final int decayFactor = MathHelper.floor(Math.sqrt(dist) / 4);
-		weight -= decayFactor;
+        final int distX = (checkX - orgX);
+        final int distZ = (checkZ - orgZ);
+        final double dist = Math.sqrt(distX * distX + distZ + distZ);
+        final int decayFactor = MathHelper.floor(Math.sqrt(dist) / 4);
+        weight -= decayFactor;
 
-		return weight;
-	}
+        return weight;
+    }
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/Weathers.java b/game/core/src/main/java/net/minecraft/core/world/weather/Weathers.java
index 8bd03d6df..60777a8d1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/Weathers.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/Weathers.java
@@ -1,61 +1,64 @@
 package net.minecraft.core.world.weather;
 
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
 public abstract class Weathers {
-    public static final Weather[] WEATHERS = new Weather[16];
-    public static final Weather OVERWORLD_CLEAR = new WeatherClear(0)
-        .setLanguageKey("overworld.clear");
-    public static final Weather OVERWORLD_RAIN = new WeatherRain(1)
-        .setLanguageKey("overworld.rain")
-        .setPrecipitation("/assets/minecraft/textures/environment/rain.png", 0)
-        .setSubtractLightLevel(3)
-        .setSpawnRainParticles(true)
-        .setFogDistance(0.5f)
-        .setDamp();
-    public static final Weather OVERWORLD_SNOW = new WeatherSnow(2)
-        .setLanguageKey("overworld.snow")
-        .setPrecipitation("/assets/minecraft/textures/environment/snow.png", 1)
-        .setSubtractLightLevel(1)
-        .setFogDistance(0.5f)
-        .setDamp();
-    public static final Weather OVERWORLD_STORM = new WeatherStorm(3)
-        .setLanguageKey("overworld.storm")
-        .setPrecipitation("/assets/minecraft/textures/environment/rain.png", 0)
-        .setSubtractLightLevel(5)
-        .setSpawnRainParticles(true)
-        .setMobsSpawnInDaylight()
-        .setFogDistance(0.4f)
-        .setDamp();
-    public static final Weather OVERWORLD_FOG = new WeatherClear(4)
-        .setLanguageKey("overworld.fog")
-        .setFogDistance(0.125f);
-    public static final Weather OVERWORLD_CLEAR_HELL = new WeatherClear(5)
-        .setLanguageKey("overworld.clear.hell")
-        .setSubtractLightLevel(7);
-    public static final Weather OVERWORLD_CLEAR_WOODS = new WeatherClear(6)
-        .setLanguageKey("overworld.clear.woods")
-        .setSubtractLightLevel(2);
-    public static final Weather OVERWORLD_WINTER_SNOW = new WeatherSnow(7)
-        .setLanguageKey("overworld.winter.snow")
-        .setPrecipitation("/assets/minecraft/textures/environment/snow.png", 1)
-        .setDamp();
-    public static final Weather OVERWORLD_RAIN_BLOOD = new WeatherStorm(8)
-        .setLanguageKey("overworld.rain.blood")
-        .setPrecipitation("/assets/minecraft/textures/environment/rain_blood.png", 2)
-        .setSubtractLightLevel(5)
-        .setMobsSpawnInDaylight()
-        .setFogDistance(0.4f)
-        .setDamp();
+    public static final @Nullable Weather @NotNull[] WEATHERS = new Weather[16];
+    public static final @NotNull Weather OVERWORLD_CLEAR = new WeatherClear(0, "overworld.clear", new WeatherConfig());
+    public static final @NotNull Weather OVERWORLD_RAIN = new WeatherRain(1, "overworld.rain",
+        new WeatherConfig()
+            .setLightLevelSubtracted(3)
+            .setFogDistanceMultiplier(0.5f)
+            .setDamp(true)
+    );
+    public static final @NotNull Weather OVERWORLD_SNOW = new WeatherSnow(2, "overworld.snow",
+        new WeatherConfig()
+            .setLightLevelSubtracted(1)
+            .setFogDistanceMultiplier(0.5f)
+            .setDamp(true)
+    );
+    public static final @NotNull Weather OVERWORLD_STORM = new WeatherStorm(3, "overworld.storm",
+        new WeatherConfig()
+            .setLightLevelSubtracted(5)
+            .setMobDaylightSpawnAllowed(true)
+            .setFogDistanceMultiplier(0.4f)
+            .setDamp(true)
+    );
+    public static final @NotNull Weather OVERWORLD_FOG = new WeatherClear(4, "overworld.fog",
+        new WeatherConfig()
+            .setFogDistanceMultiplier(0.125f)
+    );
+    public static final @NotNull Weather OVERWORLD_HELL_CLEAR = new WeatherClear(5, "overworld.hell.clear",
+        new WeatherConfig()
+            .setLightLevelSubtracted(7)
+    );
+    public static final @NotNull Weather OVERWORLD_WOODS_CLEAR = new WeatherClear(6, "overworld.woods.clear",
+        new WeatherConfig()
+            .setLightLevelSubtracted(2)
+    );
+    public static final @NotNull Weather OVERWORLD_WINTER_SNOW = new WeatherSnow(7, "overworld.winter.snow",
+        new WeatherConfig()
+            .setDamp(true)
+    );
+    public static final @NotNull Weather OVERWORLD_RAIN_BLOOD = new WeatherRainBlood(8, "overworld.rain.blood",
+        new WeatherConfig()
+            .setLightLevelSubtracted(5)
+            .setMobDaylightSpawnAllowed(true)
+            .setFogDistanceMultiplier(0.4f)
+            .setDamp(true)
+    );
 
-    public static Weather getWeatherByLanguageKey(String string) {
-        for(Weather weather : WEATHERS) {
-            if(weather != null && weather.languageKey.substring(8).equalsIgnoreCase(string)) {
+    public static @Nullable Weather getWeatherByLanguageKey(final @NotNull String languageKey) {
+        for(final @Nullable Weather weather : WEATHERS) {
+            if(weather != null && weather.getLanguageKey().substring(8).equalsIgnoreCase(languageKey)) {
                 return weather;
             }
         }
         return null;
     }
 
-    public static Weather getWeather(int i) {
+    public static @Nullable Weather getWeather(final int i) {
         return WEATHERS[i];
     }
 
diff --git a/game/core/src/main/resources/lang/en_US/item.lang b/game/core/src/main/resources/lang/en_US/item.lang
index f48e92eb3..b22bf191c 100644
--- a/game/core/src/main/resources/lang/en_US/item.lang
+++ b/game/core/src/main/resources/lang/en_US/item.lang
@@ -435,3 +435,13 @@ item.jar.butterfly.silver.desc=A glass jar containing a silver butterfly.
 
 item.statue.stone.name=Stone Statue
 item.statue.stone.desc=A decorative stone statue for you to hang your armor.
+item.statue.basalt.name=Basalt Statue
+item.statue.basalt.desc=A decorative basalt statue for you to hang your armor.
+item.statue.limestone.name=Limestone Statue
+item.statue.limestone.desc=A decorative limestone statue for you to hang your armor.
+item.statue.granite.name=Granite Statue
+item.statue.granite.desc=A decorative granite statue for you to hang your armor.
+item.statue.marble.name=Marble Statue
+item.statue.marble.desc=A decorative marble statue for you to hang your armor.
+item.statue.marble.name=Pigman Statue
+item.statue.marble.desc=An ancient stone statue found in a long-forgotten place.
diff --git a/game/core/src/main/resources/lang/en_US/options.lang b/game/core/src/main/resources/lang/en_US/options.lang
index 644440c4b..3d4a4d255 100644
--- a/game/core/src/main/resources/lang/en_US/options.lang
+++ b/game/core/src/main/resources/lang/en_US/options.lang
@@ -173,6 +173,7 @@ options.chatVisibility.never_show=Never Show
 options.developerMode=Developer Mode
 options.forceOnscreenKeyboard=Force On Screen Keyboard
 options.enableHolidayTextures=Enable Holiday Textures
+options.dynamicCursor=Dynamic Cursor
 
 options.tooltipStyle.default=Default
 options.tooltipStyle.modern=Modern
@@ -191,6 +192,8 @@ options.tooltipStyle.redstone_goggles=Redstone Goggles
 options.tooltipStyle.creep-o-vision=Creep-o-Vision
 options.tooltipStyle.steve=Steve
 
+options.playerLeftHanded=Left Handed
+
 key.attack=Attack
 key.interact=Interact
 key.pickBlock=Pick Block
diff --git a/game/core/src/main/resources/lang/en_US/strings.lang b/game/core/src/main/resources/lang/en_US/strings.lang
index b5e85bc80..d283dfed0 100644
--- a/game/core/src/main/resources/lang/en_US/strings.lang
+++ b/game/core/src/main/resources/lang/en_US/strings.lang
@@ -13,8 +13,8 @@ season.paradise.silver.name=Silver
 season.null.name=No Season
 
 weather.overworld.clear.name=Clear
-weather.overworld.clear.hell.name=Clear
-weather.overworld.clear.woods.name=Clear
+weather.overworld.hell.clear.name=Clear
+weather.overworld.woods.clear.name=Clear
 weather.overworld.rain.name=Raining
 weather.overworld.snow.name=Snowing
 weather.overworld.winter.snow.name=Snowing
diff --git a/game/core/src/main/resources/lang/en_US/tile.lang b/game/core/src/main/resources/lang/en_US/tile.lang
index f637a568d..0d792530c 100644
--- a/game/core/src/main/resources/lang/en_US/tile.lang
+++ b/game/core/src/main/resources/lang/en_US/tile.lang
@@ -1235,4 +1235,24 @@ tile.jar.butterfly.silver.desc=A glass jar containing a silver butterfly.
 tile.statue.stone.lower.name=Stone Statue (Lower)
 tile.statue.stone.lower.desc=
 tile.statue.stone.upper.name=Stone Statue (Upper)
-tile.statue.stone.upper.desc=
\ No newline at end of file
+tile.statue.stone.upper.desc=
+tile.statue.basalt.lower.name=Basalt Statue (Lower)
+tile.statue.basalt.lower.desc=
+tile.statue.basalt.upper.name=Basalt Statue (Upper)
+tile.statue.basalt.upper.desc=
+tile.statue.limestone.lower.name=Limestone Statue (Lower)
+tile.statue.limestone.lower.desc=
+tile.statue.limestone.upper.name=Limestone Statue (Upper)
+tile.statue.limestone.upper.desc=
+tile.statue.granite.lower.name=Granite Statue (Lower)
+tile.statue.granite.lower.desc=
+tile.statue.granite.upper.name=Granite Statue (Upper)
+tile.statue.granite.upper.desc=
+tile.statue.marble.lower.name=Marble Statue (Lower)
+tile.statue.marble.lower.desc=
+tile.statue.marble.upper.name=Marble Statue (Upper)
+tile.statue.marble.upper.desc=
+tile.statue.pigman.lower.name=Pigman Statue (Lower)
+tile.statue.pigman.lower.desc=
+tile.statue.pigman.upper.name=Pigman Statue (Upper)
+tile.statue.pigman.upper.desc=
\ No newline at end of file
diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index ae9dc15a5..f2d9785f7 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -535,64 +535,64 @@ public class PlayerServer extends Player implements ContainerListener {
     }
 
     @Override
-	public void displayFurnaceScreen(TileEntityFurnace blockEntity)
+	public void displayFurnaceScreen(TileEntityFurnace tileEntity)
     {
         getNextWindowId();
-        if (blockEntity instanceof TileEntityFurnaceBlast)
+        if (tileEntity instanceof TileEntityFurnaceBlast)
         {
-            playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_BLAST_FURNACE, blockEntity.getNameTranslationKey(), blockEntity.getContainerSize()));
+            playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_BLAST_FURNACE, tileEntity.getNameTranslationKey(), tileEntity.getContainerSize()));
         }
         else
         {
-            playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_FURNACE, blockEntity.getNameTranslationKey(), blockEntity.getContainerSize()));
+            playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_FURNACE, tileEntity.getNameTranslationKey(), tileEntity.getContainerSize()));
         }
         craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuFurnace(inventory, blockEntity);
+        craftingInventory = new MenuFurnace(inventory, tileEntity);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
     }
 
     @Override
-	public void displayDispenserScreen(TileEntityDispenser blockEntity)
+	public void displayDispenserScreen(TileEntityDispenser tileEntity)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_DISPENSER, blockEntity.getNameTranslationKey(), blockEntity.getContainerSize()));
+        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_DISPENSER, tileEntity.getNameTranslationKey(), tileEntity.getContainerSize()));
         craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuTrap(inventory, blockEntity);
+        craftingInventory = new MenuTrap(inventory, tileEntity);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
     }
 
     @Override
-    public void displayActivatorScreen(TileEntityActivator blockEntity)
+    public void displayActivatorScreen(TileEntityActivator tileEntity)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_ACTIVATOR, blockEntity.getNameTranslationKey(), blockEntity.getContainerSize()));
+        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_ACTIVATOR, tileEntity.getNameTranslationKey(), tileEntity.getContainerSize()));
         craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuActivator(inventory, blockEntity);
+        craftingInventory = new MenuActivator(inventory, tileEntity);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
     }
 
 
     @Override
-	public void displayTrommelScreen(TileEntityTrommel blockEntity)
+	public void displayTrommelScreen(TileEntityTrommel tileEntity)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_TROMMEL, blockEntity.getNameTranslationKey(), blockEntity.getContainerSize()));
+        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_TROMMEL, tileEntity.getNameTranslationKey(), tileEntity.getContainerSize()));
         craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuTrommel(inventory, blockEntity);
+        craftingInventory = new MenuTrommel(inventory, tileEntity);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
     }
 
     @Override
-    public void displayFlagEditorScreen(TileEntityFlag blockEntity)
+    public void displayFlagEditorScreen(TileEntityFlag tileEntity)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new PacketFlagOpen(currentWindowId, blockEntity.x, blockEntity.y, blockEntity.z));
+        playerNetServerHandler.sendPacket(new PacketFlagOpen(currentWindowId, tileEntity.x, tileEntity.y, tileEntity.z));
         craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuFlag(inventory, blockEntity);
+        craftingInventory = new MenuFlag(inventory, tileEntity);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
     }
@@ -747,7 +747,9 @@ public class PlayerServer extends Player implements ContainerListener {
     @Override
     public void setHeldObject(@Nullable ICarriable heldObject) {
         super.setHeldObject(heldObject);
-        mcServer.getEntityTracker(dimension).sendPacketToTrackedPlayers(this, new PacketSetHeldObject(id, heldObject));
+        PacketSetHeldObject object = new PacketSetHeldObject(id, heldObject);
+        playerNetServerHandler.sendPacket(object);
+        mcServer.getEntityTracker(dimension).sendPacketToTrackedPlayers(this, object);
 
         // Ensure slot is definitely synced
         playerNetServerHandler.sendPacket(new PacketSetHotbarOffset(inventory.getHotbarOffset()));
diff --git a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
index 84431d4fe..d0ce6ff27 100644
--- a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -657,7 +657,7 @@ public class PlayerList
 
     }
 
-    public void sendBlockEntityToPlayer(int x, int y, int z, int dimension, TileEntity tileEntity)
+    public void sendTileEntityToPlayer(int x, int y, int z, int dimension, TileEntity tileEntity)
     {
         getPlayerManager(dimension).markBlockNeedsUpdate(x, y, z);
     }
